<dx-data-grid class="gridContainer box-shadow" #gridControls [columnAutoWidth]='true' [allowColumnResizing]='true'
    [allowColumnReordering]='true' [rowAlternationEnabled]='ui.rowAlternationEnabled' [showColumnLines]='ui.showColumnLines'
    [showRowLines]='ui.showRowLines' [dataSource]='dsControls' [height]='ui.fullHeight' (onToolbarPreparing)="toolbarPreparing($event, 'controls')">
    <dxo-export [enabled]='true' [enabled]='true' fileName='controls'></dxo-export>
    <dxo-header-filter [visible]='true'></dxo-header-filter>
    <dxo-group-panel [visible]='true'></dxo-group-panel>
    <dxo-search-panel [visible]='true'></dxo-search-panel>
    <dxo-master-detail [enabled]='true' template='details'></dxo-master-detail>
    <dxo-state-storing [enabled]="true" type="localStorage" storageKey="qhseControls"></dxo-state-storing>
    <dxo-filter-row [visible]='true'></dxo-filter-row>
    <dxo-column-chooser [enabled]="true" mode='dragAndDrop'></dxo-column-chooser>
    <dxo-column-fixing [enabled]="true"></dxo-column-fixing>
    <dxo-remote-operations [sorting]="true" [paging]="true" [filtering]="true"></dxo-remote-operations>
    <dxo-scrolling mode='virtual' showScrollbar='onHover' [useNative]='true'></dxo-scrolling>

    <dxi-column type="buttons" fixedPosition='left' [fixed]='true' [allowResizing]='false' [showInColumnChooser]='false'>
        <dxi-button hint='Editează' icon="edit" [onClick]="onEditControlClick"></dxi-button>
        <dxi-button hint='Șterge' icon='trash' [onClick]="onDeleteControlClick"></dxi-button>
    </dxi-column>

    <dxi-column [caption]='ds.lg.format("BODY CONTROL")' dataField='c_authority' dataType='string' [allowHeaderFiltering]='false'></dxi-column>
    <dxi-column [caption]='ds.lg.format("ENTITY")' dataField='ent_name' dataType='string' [allowHeaderFiltering]='false'></dxi-column>
    <dxi-column [caption]='ds.lg.format("WORKSTATION")' dataField='wc_name' dataType='string' [allowHeaderFiltering]='false'>
    </dxi-column>
    <dxi-column [caption]='ds.lg.format("CONTROL TYPE")' dataField='c_typeId' dataType='number'>
        <dxo-lookup [dataSource]='ds.controlType' valueExpr='id' displayExpr='value'></dxo-lookup>
    </dxi-column>
    <dxi-column [caption]='ds.lg.format("PLANNED")' dataField='c_planned' dataType='boolean' minWidth='120'></dxi-column>
    <dxi-column [caption]='ds.lg.format("CONTROL REASON")' dataField='c_reason' dataType='string' [allowHeaderFiltering]='false'></dxi-column>
    <dxi-column [caption]='ds.lg.format("DATE")' dataField='c_date' dataType='date' calculateSortValue='c_date' [calculateDisplayValue]='ds.getDate'>
    </dxi-column>
    <dxi-column [caption]='ds.lg.format("CASES")' dataField='c_cases' dataType='string' [allowHeaderFiltering]='false'></dxi-column>
    <dxi-column [caption]='ds.lg.format("SANCTIONS")' dataField='c_sanction' dataType='boolean' minWidth='120'></dxi-column>
    <dxi-column [caption]='ds.lg.format("STATUS SANCTION")' dataField='c_sanctionStatus' dataType='number' [allowHeaderFiltering]='false'>
        <dxo-lookup [dataSource]='ds.sanctionStatus' valueExpr='id' displayExpr='value'></dxo-lookup>
    </dxi-column>
    <dxi-column [caption]='ds.lg.format("MEASURES")' dataField='c_action' dataType='boolean' minWidth='120'></dxi-column>
    <dxi-column [caption]='ds.lg.format("STATUS MEASURE")' dataField='c_actionStatus' dataType='number' [allowEditing]='false'
        [allowHeaderFiltering]='false'>
        <dxo-lookup [dataSource]='ds.actionStatus' valueExpr='id' displayExpr='value'></dxo-lookup>
    </dxi-column>
    <dxi-column [caption]='ds.lg.format("GENERATED COST")' dataField='c_cost' dataType='number' [allowHeaderFiltering]='false'></dxi-column>
    <dxi-column [caption]='ds.lg.format("COST DESCRIPTION")' dataField='c_costDescription' dataType='string' [allowHeaderFiltering]='false'></dxi-column>

    <div *dxTemplate="let controls of 'details'">
        <dx-tab-panel>
            <dxi-item title='Sancțiuni' *ngIf='controls.data.c_sanction'>
                <dx-data-grid class="TabPanelGrids" #gridSanctions [columnAutoWidth]='true' [allowColumnResizing]='true'
                    [allowColumnReordering]='true' [rowAlternationEnabled]='ui.rowAlternationEnabled' [showColumnLines]='ui.showColumnLines'
                    [showRowLines]='ui.showRowLines' [height]='250' (onToolbarPreparing)="toolbarPreparing($event, 'sanctions', controls.data.c_id)"
                    (onContentReady)="onSanctionsContentReady($event, controls.data)" (onCellPrepared)='ds.changeEditButtons($event)'>
                    <dxo-export [enabled]='true' [enabled]='true' fileName='generare'></dxo-export>
                    <dxo-header-filter [visible]='true'></dxo-header-filter>
                    <dxo-scrolling mode='virtual' showScrollbar='onHover' [useNative]='false'></dxo-scrolling>
                    <dxo-remote-operations [sorting]="true" [paging]="true" [filtering]="true"></dxo-remote-operations>
                    <dxo-search-panel [visible]='true'></dxo-search-panel>
                    <dxo-column-fixing [enabled]="true"></dxo-column-fixing>

                    <dxi-column type="buttons" fixedPosition='left' [fixed]='true' [allowResizing]='false'
                        [showInColumnChooser]='false'>
                        <dxi-button hint='Editează' icon="edit" [onClick]="onEditSanctionClick"></dxi-button>
                        <dxi-button hint='Șterge' icon='trash' [onClick]="onDeleteSanctionClick"></dxi-button>
                    </dxi-column>

                    <dxi-column [caption]='ds.lg.format("SANCTION DESCRIPTION")' dataField='sanctionDescription' dataType='string'>
                    </dxi-column>
                    <dxi-column [caption]='ds.lg.format("STATUS")' dataField='sanctionStatus' dataType='number'>
                        <dxo-lookup [dataSource]='ds.sanctionStatus' valueExpr='id' displayExpr='value'></dxo-lookup>
                    </dxi-column>
                    <dxi-column [caption]='ds.lg.format("SANCTION TERM")' dataField='termSanction' dataType='date' calculateSortValue='termSanction'
                        [calculateDisplayValue]='ds.getDate' [allowHeaderFiltering]='false'>
                    </dxi-column>
                    <dxi-column [caption]='ds.lg.format("OBSERVATIONS")' dataField='notifications' dataType='string'></dxi-column>

                </dx-data-grid>
            </dxi-item>

            <dxi-item title='Masuri' *ngIf='controls.data.c_action'>
                <dx-data-grid class="TabPanelGrids" #gridActions [columnAutoWidth]='true' [allowColumnResizing]='true'
                    [allowColumnReordering]='true' [rowAlternationEnabled]='ui.rowAlternationEnabled' [showColumnLines]='ui.showColumnLines'
                    [showRowLines]='ui.showRowLines' [height]='250' (onToolbarPreparing)='toolbarPreparing($event, "actions", controls.data.c_id)'
                    (onContentReady)="onActionContentReady($event, controls.data)" (onCellPrepared)='ds.changeEditButtons($event)'>
                    <dxo-export [enabled]='true' [enabled]='true' fileName='generare'></dxo-export>
                    <dxo-header-filter [visible]='true'></dxo-header-filter>
                    <dxo-scrolling mode='virtual' showScrollbar='onHover' [useNative]='false'></dxo-scrolling>
                    <dxo-remote-operations [sorting]="true" [paging]="true" [filtering]="true"></dxo-remote-operations>
                    <dxo-search-panel [visible]='true'></dxo-search-panel>

                    <dxi-column type="buttons" fixedPosition='left' [fixed]='true' [allowResizing]='false'
                        [showInColumnChooser]='false'>
                        <dxi-button hint='Editează' icon="edit" [onClick]="onEditActionClick"></dxi-button>
                        <dxi-button hint='Șterge' icon='trash' [onClick]="onDeleteActionClick"></dxi-button>
                    </dxi-column>
                    <dxi-column [caption]='ds.lg.format("MEASURE DESCRIPTION")' dataField='actionDescription' dataType='string'></dxi-column>
                    <dxi-column [caption]='ds.lg.format("STATUS")' dataField='actionStatus' dataType='number'>
                        <dxo-lookup [dataSource]='ds.actionStatus' valueExpr='id' displayExpr='value'></dxo-lookup>
                    </dxi-column>
                    <dxi-column [caption]='ds.lg.format("MEASURE TERM")' dataField='termAction' dataType='date' calculateSortValue='termAction'
                        [calculateDisplayValue]='ds.getDate' [allowHeaderFiltering]='false'>
                    </dxi-column>
                    <dxi-column [caption]='ds.lg.format("OBSERVATIONS")' dataField='notifications' dataType='string'></dxi-column>
                </dx-data-grid>
            </dxi-item>
        </dx-tab-panel>
    </div>

</dx-data-grid>

<dx-popup [(visible)]='isControlsVisible' [minWidth]='ui.minWidthPopup' width='auto' maxWidth='90vw' (onShown)='ui.onPopupShown($event)'
    (onHidden)='ui.onPopupHidden($event)' height='auto' title='Controale'>

    <div *dxTemplate="let data of 'content'">
        <dx-scroll-view [height]='ui.scrollHeight' width="auto" direction="both">
            <app-edit-control [controlForm]='ct'></app-edit-control>
        </dx-scroll-view>
    </div>
    <dxi-toolbar-item toolbar="bottom" location="after" widget="dxButton" [options]="{ text:'Salvează şi adaugă', icon: 'assets/img/grid_add.svg', type: 'normal', onClick: onSaveControlsNew, validationGroup:'ctValidation' }">
    </dxi-toolbar-item>
    <dxi-toolbar-item toolbar="bottom" location="after" widget="dxButton" [options]="{ text:'Salvează', icon:'save', type: 'normal', onClick: onSaveControls, validationGroup:'ctValidation' }">
    </dxi-toolbar-item>
</dx-popup>

<dx-popup [(visible)]='isSanctionPopupVisible' [minWidth]='ui.minWidthPopup' width='auto' maxWidth='90vw' (onShown)='ui.onPopupShown($event)'
    (onHidden)='ui.onPopupHidden($event)' height='auto' title='Sanctiuni'>
    <div *dxTemplate="let data of 'content'">
        <dx-scroll-view [height]='ui.scrollHeight' width="auto" direction="both">
            <app-edit-sanction [sanctionForm]='sanction'></app-edit-sanction>
        </dx-scroll-view>
    </div>
    <dxi-toolbar-item toolbar="bottom" location="after" widget="dxButton" [options]="{ text:'Salvează şi adaugă', icon: 'assets/img/grid_add.svg', type: 'normal', onClick: onSaveSanctionNew, validationGroup:'sanctionValidation' }">
    </dxi-toolbar-item>
    <dxi-toolbar-item toolbar="bottom" location="after" widget="dxButton" [options]="{ text:'Salvează', icon:'save', type: 'normal', onClick: onSaveSanction, validationGroup:'sanctionValidation' }">
    </dxi-toolbar-item>
</dx-popup>

<dx-popup [(visible)]='isActionPopupVisible' [minWidth]='ui.minWidthPopup' width='auto' maxWidth='90vw' (onShown)='ui.onPopupShown($event)'
    (onHidden)='ui.onPopupHidden($event)' height='auto' title='Masuri'>
    <div *dxTemplate="let data of 'content'">
        <app-edit-action [actionForm]='action'></app-edit-action>
    </div>
    <dxi-toolbar-item toolbar="bottom" location="after" widget="dxButton" [options]="{ text:'Salvează şi adaugă', icon: 'assets/img/grid_add.svg', type: 'normal', onClick: onSaveActionNew, validationGroup:'actionValidation' }">
    </dxi-toolbar-item>
    <dxi-toolbar-item toolbar="bottom" location="after" widget="dxButton" [options]="{ text:'Salvează', icon:'save', type: 'normal', onClick: onSaveAction, validationGroup:'actionValidation' }">
    </dxi-toolbar-item>
</dx-popup>